%global majorversion %%(echo %{version} | cut -d. -f1)

Summary:            PostgreSQL client library
Name:               libpq
Version:            15.13
Release:            1%{?dist}
License:            PostgreSQL
Url:                http://www.postgresql.org/
Source0:            https://ftp.postgresql.org/pub/source/v%{version}/postgresql-%{version}.tar.bz2

Patch3001:          libpq-10.3-rpm-pgsql.patch
Patch3002:          libpq-10.3-var-run-socket.patch
Patch3003:          libpq-12.1-symbol-versioning.patch

BuildRequires:      gcc make
BuildRequires:      bison flex gawk gettext
BuildRequires:      glibc-devel openssl-devel zlib-devel
BuildRequires:      krb5-devel openldap-devel
Provides:           postgresql-libs = %version-%release
# postgresql renamed lib to libpq.so.private15-5.15, which does not conflict with libpq


%description
libpq is the C application programmer's interface to PostgreSQL.
libpq is a set of library functions that allow client programs
to pass queries to the PostgreSQL backend server and to receive
the results of these queries.


%package devel
Summary:            Development files for building PostgreSQL client tools
Requires:           %name = %version-%release
Provides:           postgresql-devel = %version-%release
# provides libpq*.h, which conflicts with postgresql
Conflicts:          postgresql-private-devel

%description devel
libpq is the C application programmer's interface to PostgreSQL.
libpq is a set of library functions that allow client programs
to pass queries to the PostgreSQL backend server and to receive
the results of these queries.


%prep
%autosetup -n postgresql-%version -p1


%build
%configure \
    --disable-rpath \
    --with-ldap \
    --with-openssl \
    --with-gssapi \
    --enable-nls \
    --without-readline \
    --datadir=%_datadir/postgresql

%global build_subdirs \\\
        src/include \\\
        src/common \\\
        src/port \\\
        src/interfaces/libpq \\\
        src/bin/pg_config

for subdir in %build_subdirs; do
    %make_build -C "$subdir"
done


%install
for subdir in %build_subdirs; do
    %make_install -C "$subdir"
done

find %{buildroot} -name '*.a' -delete
rm -r %{buildroot}%_includedir/pgsql/server

%find_lang libpq5-%{majorversion}
%find_lang pg_config-%{majorversion}


%files -f libpq5-%{majorversion}.lang
%license COPYRIGHT
%doc %_datadir/postgresql/pg_service.conf.sample
%_libdir/libpq.so.5*
%dir %_datadir/postgresql


%files devel -f pg_config-%{majorversion}.lang
%_bindir/pg_config
%_includedir/*
%_libdir/libpq.so
%_libdir/pkgconfig/libpq.pc


%changelog
* Tue May 20 2025 Wang Guodong <gordonwwang@tencent.com> - 15.13-1
- Upgrade to version 15.13, fix CVE-2025-4207

* Mon Feb 24 2025 Wang Guodong <gordonwwang@tencent.com> - 15.12-1
- Upgrade to version 15.12, fix CVE-2025-1094

* Thu Sep 26 2024 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 15.3-6
- Rebuilt for clarifying the packages requirement in BaseOS and AppStream

* Fri Aug 16 2024 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 15.3-5
- Rebuilt for loongarch release

* Wed Mar 13 2024 Wang Guodong <gordonwwang@tencent.com> - 15.3-4
- OpenTenBase's lib and header files are moved and no longer Conflicts

* Fri Nov 3 2023 Wang Guodong <gordonwwang@tencent.com> - 15.3-3
- Conflicts with postgresql-private-devel, OpenTenBase-devel

* Fri Sep 08 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 15.3-2
- Rebuilt for OpenCloudOS Stream 23.09

* Wed Aug 2 2023 Shuo Wang <abushwang@tencent.com> - 15.3-1
- update to 15.3

* Fri Apr 28 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 14.5-5
- Rebuilt for OpenCloudOS Stream 23.05

* Fri Mar 31 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 14.5-4
- Rebuilt for OpenCloudOS Stream 23

* Tue Dec 13 2022 rockerzhu <rockerzhu@tencent.com> - 14.5-3
- add provides postgresql-devel

* Wed Nov 09 2022 rockerzhu <rockerzhu@tencent.com> - 14.5-2
- add provides postgresql-libs

* Wed Aug 24 2022  NewStartOS <os@gd-linux.com> - 14.5-1
- Package libpq init
